<template>
  <div>
    <div class="alert alert-info" role="alert">
      Explore Merge Requests, recently deployed to GitLab.com, and their related
      Issues.<br />
      The list is meant to be complementary to our Release posts and cover
      features and bug fixes since the last release.
      <br />
      Data is parsed from Merge Requests and APIs. It is essentially a similar
      view to this
      <a
        href="https://gitlab.com/gitlab-org/gitlab/-/merge_requests?scope=all&utf8=%E2%9C%93&state=merged&environment=gprd"
        >Merge Request List</a
      >, but we are also showing Issues which are related to those Merge
      Requests.
    </div>
    <div v-if="loading">Loading...</div>
    <template v-else>
      <form>
        <div class="form-row">
          <div class="form-group col-md-2">
            <label>Type</label><br />
            <div class="btn-group" role="group" aria-label="Basic example">
              <select class="custom-select" v-model="type">
                <option value="both">Issues & MRs</option>
                <option value="ISSUE">Issues</option>
                <option value="MR">MRs</option>
              </select>
            </div>
          </div>
          <div class="form-group col-md-2">
            <label>Deployed after</label><br />
            <input
              type="date"
              v-model="deployedAfter"
              :min="minDate"
              :max="MaxDate"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Deployed before</label><br />
            <input
              type="date"
              v-model="deployedBefore"
              :min="minDate"
              :max="MaxDate"
            />
          </div>
          <div class="form-group col-md-2">
            <div class="form-check">
              <input
                class="form-check-input"
                type="checkbox"
                v-model="show_description"
                id="defaultCheck1"
              />
              <label class="form-check-label" for="defaultCheck1">
                Show (and search) descriptions
              </label>
            </div>
            <div class="form-check">
              <input
                class="form-check-input"
                type="checkbox"
                v-model="absolute_dates"
                id="defaultCheck2"
              />
              <label class="form-check-label" for="defaultCheck2">
                Use Absolute dates
              </label>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Fulltext search</label>
            <input
              class="form-control"
              :placeholder="
                'Search item title' +
                (show_description ? ' (and description)' : '')
              "
              v-model="textSearch"
            />
          </div>
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Label search</label>
            <input
              class="form-control"
              placeholder="Search by label"
              v-model="labelSearch"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Order By</label><br />
            <div class="btn-group" role="group" aria-label="Basic example">
              <select class="custom-select" v-model="orderKey">
                <option value="deployed_to_prod">Deployment date</option>
              </select>
              <button
                type="button"
                @click="order = order * -1"
                class="btn btn-outline-dark"
              >
                {{ order < 0 ? "Asc" : "Desc" }}
              </button>
            </div>
          </div>
        </div>
      </form>
      <hr />
      <paginated-table
        :items="filteredMergeRequests"
        :total-items="mergeRequests.length"
        :per-page-default="100"
      >
        <template v-slot:header>
          <tr>
            <th>Deployed to GitLab.com</th>
            <th>Description</th>
            <th>Labels</th>
            <th>Related items</th>
          </tr>
        </template>
        <template v-slot:row="{ item: merge_request }">
          <td>
            <abbr :title="merge_request.deployed_to_prod">
              {{ timeago(merge_request.deployed_to_prod) }}
            </abbr>
          </td>
          <td class="md">
            <h2 style="font-size: 1.5rem">
              {{ merge_request.title }}
              <br />
              <small>
                {{ merge_request.type }}:
                <a :href="merge_request.web_url" target="_blank">{{
                  merge_request.reference
                }}</a>
              </small>
            </h2>
            <br />
            <span
              v-if="show_description"
              v-html="merge_request.description_html"
            />
          </td>
          <td>
            <ul v-if="merge_request.labels.length">
              <li v-for="label in merge_request.labels">{{ label }}</li>
            </ul>
            <template v-else>N/A</template>
          </td>
          <td>
            <ul>
              <li v-for="mr in merge_request.related_mrs">
                MR: <a :href="mr" target="_blank">{{ referencify(mr) }}</a>
              </li>
              <li v-for="issue in merge_request.related_issues">
                Issue:
                <a :href="issue" target="_blank">{{ referencify(issue) }}</a>
              </li>
            </ul>
          </td>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<style>
.md {
  max-width: 600px;
}

.md table {
  max-width: 600px;
}

.md img {
  max-width: 100%;
}

.md h1 {
  font-size: 1.5rem;
}

.md h2 {
  font-size: 1.25rem;
}

.md h3,
.md h4,
.md h5,
.md h6 {
  font-size: 1rem;
}
</style>
<script>
import PaginatedTable from "./components/paginated-table.vue";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

let searchDefaults = {
  order: 1,
  orderKey: "deployed_to_prod",
  textSearch: "",
  labelSearch: "",
  type: "both",
  deployedAfter: null,
  deployedBefore: null,
  show_description: false,
  absolute_dates: false,
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

const rtf = new Intl.RelativeTimeFormat("en", {
  localeMatcher: "best fit", // other values: "lookup"
  numeric: "always", // other values: "auto"
  style: "long", // other values: "short" or "narrow"
});

const now = new Date();

export default {
  components: { PaginatedTable },
  data() {
    return {
      data: [],
      loading: true,
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./dot_com.json");

    this.data = await response.json();
    const params = new URLSearchParams(window.location.search);

    searchDefaults.deployedBefore = this.dates.slice(-1)[0];
    searchDefaults.deployedAfter = this.dates[0];

    this.deployedBefore = searchDefaults.deployedBefore;
    this.deployedAfter = searchDefaults.deployedAfter;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
    this.$parent.pageView({ page: "dotcom" });
    this.loading = false;
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }

      params.set("tab", "dot-com");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    timeago(date) {
      if (this.absolute_dates) {
        return date;
      }
      const diff = new Date(date) - now;

      const MINUTE = 60 * 1000;
      const HOUR = 60 * MINUTE;
      const DAY = 24 * HOUR;

      if (Math.abs(diff) > DAY) {
        return rtf.format(Math.round(diff / DAY), "day");
      }

      if (Math.abs(diff) > HOUR) {
        return rtf.format(Math.round(diff / HOUR), "hour");
      }

      return rtf.format(Math.round(diff / MINUTE), "minute");
    },
    referencify(url) {
      return url
        .replace("https://gitlab.com/", "")
        .replace(/\/(-\/)?issues\//, "#")
        .replace(/\/(-\/)?merge_requests\//, "!");
    },
    renderVersion(version) {
      return version.replace(/_0?/, ".").replace(/^0/, "").replace(/_0?/, ".");
    },
  },
  computed: {
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    labelSearchLower() {
      return this.labelSearch.toLocaleLowerCase();
    },
    mergeRequests() {
      return this.data;
    },
    dates() {
      const dates = this.mergeRequests
        .flatMap((x) => (x.deployed_to_prod ? x.deployed_to_prod : []))
        .sort();

      if (dates.length) {
        const maxDate = new Date(dates.slice(-1)[0]);

        maxDate.setDate(maxDate.getDate() + 1);
        dates.push(maxDate.toISOString());
      }

      return [...new Set(dates.map((x) => x.substring(0, 10)))].sort();
    },
    maxDate() {
      return this.dates.slice(-1)[0];
    },
    minDate() {
      return this.dates[0];
    },
    filteredMergeRequests() {
      return this.data
        .flat(Infinity)
        .filter((mergeRequest) => {
          let visible = true;

          if (visible && this.type !== "both") {
            visible = visible && mergeRequest.type === this.type;
          }

          if (visible && this.textSearch) {
            visible =
              visible &&
              (mergeRequest.title
                .toLocaleLowerCase()
                .includes(this.searchLower) ||
                (this.show_description &&
                  mergeRequest.description_html
                    .toLocaleLowerCase()
                    .includes(this.searchLower)));
          }

          if (visible && this.labelSearch) {
            visible =
              visible &&
              mergeRequest.labels
                .join("|")
                .toLocaleLowerCase()
                .includes(this.labelSearchLower);
          }

          visible =
            visible &&
            mergeRequest.deployed_to_prod <= this.deployedBefore &&
            this.deployedAfter <= mergeRequest.deployed_to_prod;

          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
